"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
exports.__esModule = true;
var React = require("react");
var react_redux_1 = require("react-redux");
var redux_1 = require("redux");
var redux_thunk_1 = require("redux-thunk");
var BindReact = /** @class */ (function (_super) {
    __extends(BindReact, _super);
    function BindReact() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BindReact.prototype.show = function (dispatch, Dev) {
        var Module = this.props.module;
        return (React.createElement("div", null,
            React.createElement(Module, __assign({}, this.props.moduleProps, { dispatch: dispatch })),
            Dev ? React.createElement(Dev, null) : '',
            this.props.children));
    };
    BindReact.prototype.render = function () {
        // add dispatch attribute to window
        var store = this.props.stories;
        window['dispatch'] = this.dispatch = store.dispatch;
        return (React.createElement(react_redux_1.Provider, { store: store }, this.show(this.dispatch, this.props.devTools)));
    };
    return BindReact;
}(React.Component));
exports["default"] = function (props) {
    var reducers = props.reducers, _a = props.middleware, middleware = _a === void 0 ? [] : _a, devTools = props.devTools, initialState = props.initialState;
    var createStoreWithMiddleware;
    // return a function contain compatible API
    var middlewareList = [
        redux_thunk_1["default"]
    ].concat(middleware);
    if (devTools) {
        createStoreWithMiddleware = redux_1.compose(
        // add middleware ahead
        redux_1.applyMiddleware.apply(void 0, middlewareList), 
        // start dev-tools
        devTools.instrument());
    }
    else {
        createStoreWithMiddleware = (redux_1.applyMiddleware.apply(void 0, middlewareList));
    }
    // just use like as createStore()
    var app = redux_1.combineReducers(__assign({}, reducers));
    var store;
    if (initialState) {
        store = createStoreWithMiddleware(redux_1.createStore)(app, initialState);
    }
    else {
        store = createStoreWithMiddleware(redux_1.createStore)(app);
    }
    return {
        getStore: function () {
            return store;
        },
        getComponent: function () {
            return BindReact;
        }
    };
};
//# sourceMappingURL=BindReact.js.map